<template>
  <div class="flex flex-col gap-2 items-center justify-center">
    <div  class="flex gap-2">
    <button @click="currentIndex--;" class="bg-citadel-500 disabled:bg-citadel-300/50 rounded-full size-12"
            :disabled="currentIndex === 0"
    ><
    </button>
    <form @submit.prevent="formSubmit">
      <input class="text-3xl font-bold w-64 p-1 rounded" placeholder="Word" v-model="currentInput"/>
    </form>
    <button @click="formSubmit" class="bg-citadel-500 disabled:bg-citadel-300/50 rounded-full size-12"
            :disabled="currentInput === ''"
    >>
    </button>
    </div>
    <p>{{currentIndex + 1}} / 24</p>
  </div>
</template>

<script setup lang="ts">
const currentIndex = ref(0);
const currentInput = ref("");
const props = defineProps({
  modelValue: {
    type: Array as PropType<string[]>,
    required: true,
  },
});

const emit = defineEmits(["submit", "update:modelValue"]);

const formSubmit = () => {
  const arrayClone = Array.from(props.modelValue);
  arrayClone[currentIndex.value!] = currentInput.value;
  emit("update:modelValue", arrayClone);
  if (currentIndex.value < 23) {
    currentIndex.value++;
  } else {
    emit("submit");
  }
}

currentInput.value = props.modelValue[currentIndex.value] || "";

watch(currentIndex, () => {
  currentInput.value = props.modelValue[currentIndex.value] || "";
});
</script>
